/*
* BrainBrowser: Web-based Neurological Visualization Tools
* (https://brainbrowser.cbrain.mcgill.ca)
*
* Copyright (C) 2011
* The Royal Institution for the Advancement of Learning
* McGill University
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
* BrainBrowser v2.0.1
*
* Author: Tarek Sherif  <tsherif@gmail.com> (http://tareksherif.ca/)
* Author: Nicolas Kassis
*/
!function(){"use strict";var a="2.0.1";a=a.indexOf("BRAINBROWSER_VERSION")>0?"D.E.V":a,window.BrainBrowser={version:a},window.requestAnimationFrame=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(a){return window.setTimeout(a,1e3/60)},window.cancelAnimationFrame=window.cancelAnimationFrame||function(a){window.clearTimeout(a)}}(),function(){"use strict";function a(b,c,d,e){return c>d?e(b):void Object.keys(b).forEach(function(f){a(b[f],c+1,d,e)})}BrainBrowser.createTreeStore=function(){var b={};return{set:function(){var a,c,d,e,f=arguments[arguments.length-1],g=Array.prototype.slice.call(arguments,0,arguments.length-1),h=b;for(c=0,d=g.length-1;d>c;c++){if(a=g[c],h[a]&&"object"!=typeof h[a])throw e="Hash key '["+g.slice(0,c+1).join("][")+"]' has already been set to a non-object value.\nCannot set '["+g.join("][")+"]'",BrainBrowser.events.triggerEvent("error",e),new Error(e);h[a]||(h[a]={}),h=h[a]}a=g[c],h[a]=f},get:function(){var a,c,d,e=Array.prototype.slice.call(arguments),f=b;if(0===e.length)return b;for(c=0,d=e.length-1;d>c;c++){if(a=e[c],void 0===f[a])return null;f=f[a]}return a=e[c],void 0!==f[a]?f[a]:null},remove:function(){var a,c,d,e,f=Array.prototype.slice.call(arguments),g=b;for(c=0,d=f.length-1;d>c;c++){if(a=f[c],void 0===g[a])return null;g=g[a]}return a=f[c],e=g[a],g[a]=void 0,e},reset:function(a){a=a&&"object"==typeof a?a:{},b=a},forEach:function(c,d){c=c>0?c:1,a(b,1,c,d)}}}}(),function(){"use strict";BrainBrowser.createColorMap=function(a){function b(a,b,d,e){var f,g,h,i=document.createElement("canvas"),j=new Array(256);for(i.width=256,i.height=d,f=0;256>f;f++)e?j[255-f]=f:j[f]=f;for(a=c.mapColors(j,{scale255:!0}),h=i.getContext("2d"),g=0;256>g;g++)h.fillStyle="rgb("+Math.floor(a[4*g])+", "+Math.floor(a[4*g+1])+", "+Math.floor(a[4*g+2])+")",h.fillRect(g,0,1,b);return i}var c={createCanvasWithScale:function(a,d,e){e=e||{};var f,g,h=c.colors,i=e.flip,j=d-a;return f=b(h,20,40,i),g=f.getContext("2d"),g.fillStyle="#FFA000",g.fillRect(.5,20,1,10),g.fillText(a.toPrecision(3),.5,40),g.fillRect(f.width/4,20,1,10),g.fillText((a+.25*j).toPrecision(3),.25*f.width,40),g.fillRect(f.width/2,20,1,10),g.fillText((a+.5*j).toPrecision(3),.5*f.width,40),g.fillRect(3*f.width/4,20,1,10),g.fillText((a+.75*j).toPrecision(3),.75*f.width,40),g.fillRect(f.width-.5,20,1,10),g.fillText(d.toPrecision(3),f.width-20,40),f},mapColors:function(a,b){b=b||{};var d,e,f,g,h=void 0===b.min?0:b.min,i=void 0===b.max?255:b.max,j=void 0===b.scale255?!1:b.scale255,k=void 0===b.brightness?0:b.brightness,l=void 0===b.contrast?1:b.contrast,m=void 0===b.alpha?1:b.alpha,n=b.destination||[],o=c.colors,p=o.length,q=i-h,r=(q+q/p)/p,s=j?255:1,t=[];for(m*=s,d=0,e=a.length;e>d;d++)g=a[d],f=h>=g?0:a[d]>i?p-1:Math.floor((g-h)/r),t=o[f]||[0,0,0],n[4*d+0]=s*(t[0]*l+k),n[4*d+1]=s*(t[1]*l+k),n[4*d+2]=s*(t[2]*l+k),n[4*d+3]=m;return n}};return function(){if(a){a=a.replace(/^\s+/,"").replace(/\s+$/,"");var b,d,e,f,g,h=a.split(/\n/),i=[];for(b=0,e=h.length;e>b;b++)if(g=h[b].replace(/^\s+/,"").replace(/\s+$/,"").split(/\s+/).slice(0,4),f=g.length,!(3>f)){for(d=0;f>d;d++)g[d]=parseFloat(g[d]);4>f&&g.push(1),i.push(g)}c.colors=i}}(),c}}(),function(){"use strict";var a=BrainBrowser.createTreeStore();BrainBrowser.config={set:function(b,c){b=b||"";var d=b.split(".");d.push(c),a.set.apply(a,d)},get:function(b){b=b||"";var c=b.split(".");return a.get.apply(a,c)}}}(),function(){"use strict";var a=[];BrainBrowser.events={addEventListener:function(b,c){a[b]||(a[b]=[]),a[b].push(c)},triggerEvent:function(b){var c=Array.prototype.slice.call(arguments,1);a[b]&&a[b].forEach(function(a){setTimeout(function(){a.apply(null,c)},0)})}}}(),function(){"use strict";var a=BrainBrowser.loader={loadFromURL:function(b,c,d){d=d||{};var e,f=new XMLHttpRequest,g=d.result_type,h=b.split("/"),i=h[h.length-1];f.open("GET",b),"arraybuffer"===g&&(f.responseType="arraybuffer"),f.onreadystatechange=function(){if(4===f.readyState){if(e=f.status,!(e>=200&&300>e||304===e)){var g="error loading URL: "+b+"\nHTTP Response: "+f.status+"\nHTTP Status: "+f.statusText+"\nResponse was: \n"+f.response;throw BrainBrowser.events.triggerEvent("error",g),new Error(g)}a.checkCancel(d)||c(f.response,i,d)}},f.send()},loadFromFile:function(a,b,c){var d=a.files;if(0!==d.length){c=c||{};var e=c.result_type,f=new FileReader,g=a.value.split("\\"),h=g[g.length-1];f.file=d[0],f.onloadend=function(a){b(a.target.result,h,c)},f.onerror=function(){var a="error reading file: "+h;throw BrainBrowser.events.triggerEvent("error",a),new Error(a)},"arraybuffer"===e?f.readAsArrayBuffer(d[0]):f.readAsText(d[0])}},loadColorMapFromURL:function(a,b,c){BrainBrowser.loader.loadFromURL(a,function(a,c,d){b(BrainBrowser.createColorMap(a),c,d)},c)},loadColorMapFromFile:function(a,b,c){BrainBrowser.loader.loadFromFile(a,function(a,c,d){b(BrainBrowser.createColorMap(a),c,d)},c)},checkCancel:function(a){a=a||{},BrainBrowser.utils.isFunction(a)&&(a={test:a});var b=a.test,c=a.cleanup,d=!1;return b&&b()&&(d=!0,c&&c()),d}}}(),function(){"use strict";BrainBrowser.utils={canvasEnabled:function(){return!!document.createElement("canvas")},webglEnabled:function(){var a=document.createElement("canvas");try{return!(!a||!window.WebGLRenderingContext||!a.getContext("webgl")&&!a.getContext("experimental-webgl"))}catch(b){return!1}},webWorkersEnabled:function(){return!!window.Worker},webGLErrorMessage:function(){var a,b='BrainBrowser requires <a href="http://khronos.org/webgl/wiki/Getting_a_WebGL_Implementation">WebGL</a>.<br/>';return b+=window.WebGLRenderingContext?"Your browser seems to support it, but it is <br/> disabled or unavailable.<br/>":"Your browser does not seem to support it.<br/>",b+='Test your browser\'s WebGL support <a href="http://get.webgl.org/">here</a>.',a=document.createElement("div"),a.id="webgl-error",a.innerHTML=b,a},isFunction:function(a){return a instanceof Function||"function"==typeof a},isNumeric:function(a){return!isNaN(parseFloat(a))},min:function(){var a=Array.prototype.slice.call(arguments);a=1===a.length&&Array.isArray(a[0])?a[0]:a;var b,c,d=a[0];for(b=1,c=a.length;c>b;b++)a[b]<d&&(d=a[b]);return d},max:function(){var a=Array.prototype.slice.call(arguments);a=1===a.length&&Array.isArray(a[0])?a[0]:a;var b,c,d=a[0];for(b=1,c=a.length;c>b;b++)a[b]>d&&(d=a[b]);return d},getOffset:function(a){for(var b=0,c=0;a.offsetParent;)b+=a.offsetTop,c+=a.offsetLeft,a=a.offsetParent;return{top:b,left:c}},captureMouse:function(a){var b={x:0,y:0,left:!1,middle:!1,right:!1};return document.addEventListener("mousemove",function(c){var d,e,f=BrainBrowser.utils.getOffset(a);void 0!==c.pageX?(d=c.pageX,e=c.pageY):(d=c.clientX+window.pageXOffset,e=c.clientY+window.pageYOffset),b.x=d-f.left,b.y=e-f.top},!1),a.addEventListener("mousedown",function(a){a.preventDefault(),0===a.button&&(b.left=!0),1===a.button&&(b.middle=!0),2===a.button&&(b.right=!0)},!1),a.addEventListener("mouseup",function(a){a.preventDefault(),0===a.button&&(b.left=!1),1===a.button&&(b.middle=!1),2===a.button&&(b.right=!1)},!1),a.addEventListener("mouseleave",function(a){a.preventDefault(),b.left=b.middle=b.right=!1},!1),a.addEventListener("contextmenu",function(a){a.preventDefault()},!1),b},captureTouch:function(a){function b(b){var d,e,f,g,h,i=BrainBrowser.utils.getOffset(a);for(c.length=g=b.touches.length,f=0;g>f;f++)h=b.touches[f],void 0!==h.pageX?(d=h.pageX,e=h.pageY):(d=h.clientX+window.pageXOffset,e=h.clientY+window.pageYOffset),c[f]=c[f]||{},c[f].x=d-i.left,c[f].y=e-i.top}var c=[];return a.addEventListener("touchstart",b,!1),a.addEventListener("touchmove",b,!1),a.addEventListener("touchend",b,!1),c}}}(),function(){"use strict";function a(a){var c,d=BrainBrowser.config.get("worker_dir");if(null===d)throw c="error in SurfaceViewer configuration.\nBrainBrowser configuration parameter 'worker_dir' not defined.\nUse 'BrainBrowser.config.set(\"worker_dir\", ...)' to set it.",BrainBrowser.events.triggerEvent("error",c),new Error(c);var e,f={deindex:"deindex.worker.js"},g=0,h=BrainBrowser.config.get("model_types"),i=BrainBrowser.config.get("intensity_data_types");return null!==h&&Object.keys(h).forEach(function(a){f[a+"_model"]=h[a].worker}),null!==i&&Object.keys(i).forEach(function(a){f[a+"_intensity"]=i[a].worker}),e=Object.keys(f),0===e.length?void a():void(window.URL&&window.URL.createObjectURL?e.forEach(function(c){var h,i,j=d+"/"+f[c],k=new XMLHttpRequest;k.open("GET",j),k.onreadystatechange=function(){4===k.readyState&&(h=k.status,h>=200&&300>h||304===h?(i=new Blob([k.response],{type:"application/javascript"}),b.worker_urls[c]=window.URL.createObjectURL(i)):b.worker_urls[c]=j,++g===e.length&&a())},k.send()}):(e.forEach(function(a){b.worker_urls[a]=d+"/"+f[a]}),a()))}var b=BrainBrowser.SurfaceViewer={start:function(c,d){if(console.log("BrainBrowser Surface Viewer v"+BrainBrowser.version),!BrainBrowser.utils.webWorkersEnabled())return void alert("Can't find web workers. Exiting.");if(!BrainBrowser.utils.webglEnabled())return void alert("Can't get WebGL context. Exiting.");var e={},f=document.getElementById(c),g={dom_element:f,model:null,model_data:null,mouse:BrainBrowser.utils.captureMouse(f),touches:BrainBrowser.utils.captureTouch(f),getAttribute:function(a){return e[a]},setAttribute:function(a,b){e[a]=b},getVertex:function(a,b){b=b||{};var c=g.model_data.get(b.model_name).vertices,d=3*a;return new THREE.Vector3(c[d],c[d+1],c[d+2])}};return Object.keys(b.modules).forEach(function(a){b.modules[a](g)}),a(function(){d(g)}),g}};b.modules={},b.worker_urls={},BrainBrowser.config.set("model_types.json.worker","json.worker.js"),BrainBrowser.config.set("model_types.mniobj.worker","mniobj.worker.js"),BrainBrowser.config.set("model_types.wavefrontobj.worker","wavefrontobj.worker.js"),BrainBrowser.config.set("model_types.freesurferasc.worker","freesurferasc.worker.js"),BrainBrowser.config.set("intensity_data_types.mniobj.worker","mniobj.intensity.worker.js"),BrainBrowser.config.set("intensity_data_types.freesurferasc.worker","freesurferasc.intensity.worker.js")}(),BrainBrowser.SurfaceViewer.parseIntensityData=function(a,b,c){"use strict";function d(){var b=new Worker(BrainBrowser.SurfaceViewer.worker_urls[f]);b.addEventListener("message",function(a){var d,e=a.data;for(d in e)e.hasOwnProperty(d)&&(g[d]=e[d]);c&&c(g),b.terminate()}),b.postMessage({cmd:"parse",data:a})}var e,f=b+"_intensity";if(!BrainBrowser.SurfaceViewer.worker_urls[f])throw e="error in SurfaceViewer configuration.\nIntensity data worker URL for "+b+" not defined.\nUse 'BrainBrowser.config.set(\"intensity_data_types."+b+".worker\", ...)' to set it.",BrainBrowser.events.triggerEvent("error",e),new Error(e);var g={};a&&("string"==typeof a?d(a):a.values?(g.values=a.values.concat(),g.min=BrainBrowser.utils.min(g.values),g.max=BrainBrowser.utils.max(g.values)):(g.values=a,g.min=BrainBrowser.utils.min(a),g.max=BrainBrowser.utils.max(a)))},BrainBrowser.SurfaceViewer.modules.annotations=function(a){"use strict";function b(b){b=b||{};var c=b.model_name||null;return!c&&a.model.children[0]&&(c=a.model.children[0].model_name),c}var c=BrainBrowser.createTreeStore(),d=.5,e=65280,f=16711680;a.annotations={add:function(e,g,h){h=h||{};var i,j,k=b(h);k&&(j=a.getVertex(e,{model_name:h.model_name}),i=a.drawDot(j.x,j.y,j.z,d,f),i.annotation_info={data:g,model_name:k,vertex:e,position:j},c.set(k,e,i),h.activate!==!1&&this.activate(e,h))},get:function(a,d){d=d||{};var e,f=b(d);return f?(e=c.get(f,a),d.activate!==!1&&this.activate(a,d),e):null},remove:function(d,e){e=e||{};var f,g=b(e);return g?(f=c.remove(g,d),a.model.remove(f),f):null},reset:function(){this.forEach(function(b){a.model.remove(b)}),c.reset()},activate:function(a,b){b=b||{};var c=this.get(a,{model_name:b.model_name,activate:!1});c&&this.forEach(function(a){a.material.color.setHex(a===c?e:f)})},forEach:function(a){c.forEach(2,a)},setMarkerOnColor:function(a){e=a},setMarkerOffColor:function(a){f=a},setMarkerRadius:function(a){d=a}}},BrainBrowser.SurfaceViewer.modules.color=function(a){"use strict";function b(b,c,d){var e,f,g,h,i,j=b.values,k=a.model_data.get(c).colors,l=b.range_min,m=b.range_max,n=a.getAttribute("flip_colors"),o=a.getAttribute("clamp_colors"),p=a.color_map.colors,q=new Float32Array(4*j.length),r=p.length,s=m-l,t=(s+s/r)/r,u=!1;for(e=0,g=j.length;g>e;e++)i=j[e],u=!1,l>i?o?h=0:u=!0:i>m?o?h=r-1:u=!0:h=Math.floor((i-l)/t),f=4*e,u?4===k.length?(q[f]=k[0],q[f+1]=k[1],q[f+2]=k[2],q[f+3]=k[3]):(q[f]=k[4*e],q[f+1]=k[4*e+1],q[f+2]=k[4*e+2],q[f+3]=k[4*e+3]):n?(q[f]=p[r-1-h][0],q[f+1]=p[r-1-h][1],q[f+2]=p[r-1-h][2],q[f+3]=p[r-1-h][3]):(q[f]=p[h][0],q[f+1]=p[h][1],q[f+2]=p[h][2],q[f+3]=p[h][3]);d&&d(q)}function c(a,b){var c,d,e,f,g,h,i,j,k,l,m,n,o,p;for(i=0,k=b.length;k>i;i++){for(d=b[i],l=d.getObjectByName("__WIREFRAME__"),p=!!l,p&&(m=l.geometry.attributes.color.array),c=d.geometry,e=d.geometry.original_data.indices,f=c.attributes.color,g=f.array,h=0,j=e.length;j>h;h+=3)n=4*h,o=2*n,g[n]=a[4*e[h]],g[n+1]=a[4*e[h]+1],g[n+2]=a[4*e[h]+2],g[n+3]=1,g[n+4]=a[4*e[h+1]],g[n+5]=a[4*e[h+1]+1],g[n+6]=a[4*e[h+1]+2],g[n+7]=1,g[n+8]=a[4*e[h+2]],g[n+9]=a[4*e[h+2]+1],g[n+10]=a[4*e[h+2]+2],g[n+11]=1,p&&(m[o]=g[n],m[o+1]=g[n+1],m[o+2]=g[n+2],m[o+3]=g[n+3],m[o+4]=g[n+4],m[o+5]=g[n+5],m[o+6]=g[n+6],m[o+7]=g[n+7],m[o+8]=g[n+4],m[o+9]=g[n+5],m[o+10]=g[n+6],m[o+11]=g[n+7],m[o+12]=g[n+8],m[o+13]=g[n+9],m[o+14]=g[n+10],m[o+15]=g[n+11],m[o+16]=g[n+8],m[o+17]=g[n+9],m[o+18]=g[n+10],m[o+19]=g[n+11],m[o+20]=g[n],m[o+21]=g[n+1],m[o+22]=g[n+2],m[o+23]=g[n+3]);f.needsUpdate=!0,p&&(l.geometry.attributes.color.needsUpdate=!0)}}function d(b){var c,d,e,f,g,h,i,j=a.color_map,k=[];for(b.forEach(function(a){k.push(j.mapColors(a.values,{min:a.range_min,max:a.range_max,alpha:a.alpha}))}),c=new Float32Array(k[0].length),d=0,h=k[0].length/4;h>d;d++)for(e=0,g=k.length;g>e;e++)f=4*d,i=k[e][f+3],c[f]+=k[e][f]*i,c[f+1]+=k[e][f+1]*i,c[f+2]+=k[e][f+2]*i,c[f+3]+=i;return c}var e=null;a.updateColors=function(f,g){function h(b){var d,e=a.model.getObjectByName(f.apply_to_shape,!0);d=e?[e]:a.model.children,c(b,d),BrainBrowser.events.triggerEvent("updatecolors",b),j&&j()}g=g||{};var i=g.blend,j=g.complete;clearTimeout(e),e=setTimeout(function(){i?h(d(f)):b(f,g.model_name,h)},0)},a.setIntensityRange=function(b,c,d){d=d||{};var e=a.model_data.get(d.model_name).intensity_data;e.range_min=b,e.range_max=c,a.updateColors(e,{complete:d.complete}),BrainBrowser.events.triggerEvent("rangechange",e)},a.blend=function(b){var c,d=a.blend_data,e=d.length;for(d[0].alpha=b,d[1].alpha=1-b,c=2;e>c;c++)d[c].alpha=0;a.updateColors(d,{blend:!0})}},BrainBrowser.SurfaceViewer.modules.loading=function(a){"use strict";function b(a,b,c){c=c||{};var d=c.format||"mniobj",g=c.parse||{};e(a,d,g,function(a){BrainBrowser.loader.checkCancel(c.cancel)||f(a,b,c)})}function c(b,c,d){d=d||{};var e=d.name||c,f=d.format||"mniobj",g=a.model_data.get(d.model_name),h=1===d.blend_index?d.blend_index:0,i=1-h,j={};a.getAttribute("fix_color_range")&&g.intensity_data&&(j={min:g.intensity_data.range_min,max:g.intensity_data.range_max}),a.blend_data=a.blend_data||[],l.parseIntensityData(b,f,function(b){var c,f;a.getAttribute("fix_color_range")&&void 0!==j.min&&void 0!==j.max?(c=j.min,f=j.max):(c=void 0===d.min?b.min:d.min,f=void 0===d.max?b.max:d.max),b.filename=e,b.apply_to_shape=d.apply_to_shape,b.applied=!1,g.intensity_data=b,a.blend_data[h]=b,b.range_min=c,b.range_max=f,a.blend_data[i]&&a.blend_data[i].applied?(a.blend_data[i].range_min=BrainBrowser.utils.min(a.blend_data[i].values),a.blend_data[i].range_max=BrainBrowser.utils.max(a.blend_data[i].values),a.blend(.5),BrainBrowser.events.triggerEvent("loadintensitydata",a.blend_data),BrainBrowser.events.triggerEvent("blendcolormaps",b.range_min,b.range_max,b)):(BrainBrowser.events.triggerEvent("loadintensitydata",b),a.updateColors(b,{complete:d.complete})),b.applied=!0})}function d(b,c,d){d=d||{};var e=a.model_data.get(d.model_name);a.color_map=b,BrainBrowser.events.triggerEvent("loadcolormap",b),e&&e.intensity_data&&a.updateColors(e.intensity_data,{filename:c})}function e(a,b,c,d){var e,f=b+"_model";if(!l.worker_urls[f])throw e="error in SurfaceViewer configuration.\nModel worker URL for "+b+" not defined.\nUse 'BrainBrowser.config.set(\"model_types."+b+".worker\", ...)' to set it.",BrainBrowser.events.triggerEvent("error",e),new Error(e);var g,h=new Worker(l.worker_urls[f]);h.addEventListener("message",function(a){var f=a.data;if(f.error)throw e="error parsing model.\n"+f.error_message+"\nFile type: "+b+"\nOptions: "+JSON.stringify(c),BrainBrowser.events.triggerEvent("error",e),new Error(e);d&&(g=new Worker(l.worker_urls.deindex),g.addEventListener("message",function(a){d(a.data)}),g.postMessage(f)),h.terminate()}),h.postMessage({data:a,options:c})}function f(b,c,d){d=d||{};var e=d.render_depth,f=d.complete;g(b,c,e),BrainBrowser.events.triggerEvent("displaymodel",a.model),f&&f()}function g(b,c,d){var e,f,g,i,k=a.model,l=b.shapes,m=b.name||c,n="line"===b.type;if(j(m,b),l){for(g=0,i=l.length;i>g;g++)f=b.shapes[g],e=h(f,n),e.model_name=m,e.name=f.name||c+"_"+(g+1),e.geometry.original_data={vertices:b.vertices,indices:f.indices,normals:b.normals,colors:b.colors},d&&(e.renderDepth=d),k.add(e);b.split&&(k.children[0].name="left",k.children[0].model_num=0,k.children[1].name="right",k.children[1].model_num=1)}}function h(a,b){var c,d,e=a.unindexed,f=a.wireframe,g=a.centroid,h=e.position,j=e.normal||[],k=e.color||[],l=new THREE.BufferGeometry;return l.dynamic=!0,l.attributes.position={itemSize:3,array:new Float32Array(h),numItems:h.length},j.length>0?l.attributes.normal={itemSize:3,array:new Float32Array(j)}:l.computeVertexNormals(),k.length>0&&(l.attributes.color={itemSize:4,array:new Float32Array(k)}),b?(c=new THREE.LineBasicMaterial({vertexColors:THREE.VertexColors}),d=new THREE.Line(l,c,THREE.LinePieces)):(c=new THREE.MeshPhongMaterial({color:16777215,ambient:16777215,specular:1052688,shininess:150,vertexColors:THREE.VertexColors}),d=new THREE.Mesh(l,c),d.add(i(d,f))),d.centroid=g,d.position.set(g.x,g.y,g.z),d}function i(a,b){var c,d,e=new THREE.BufferGeometry;return e.attributes.position={itemSize:3,array:b.position,numItems:b.position.length},e.attributes.color={itemSize:4,array:b.color},e.attributes.color.needsUpdate=!0,c=new THREE.LineBasicMaterial({vertexColors:THREE.VertexColors}),d=new THREE.Line(e,c,THREE.LinePieces),d.name="__WIREFRAME__",d.visible=!1,a.wireframe_active=!1,d}function j(a,b){n[a]=b}function k(){n={}}var l=BrainBrowser.SurfaceViewer,m=BrainBrowser.loader,n={};a.model_data={get:function(a){return a=a||Object.keys(n)[0],n[a]||null},forEach:function(a){Object.keys(n).forEach(function(b){a(n[b],b)})}},a.loadModelFromURL=function(a,c){m.loadFromURL(a,b,c)},a.loadModelFromFile=function(a,c){m.loadFromFile(a,b,c)},a.loadIntensityDataFromURL=function(a,b){m.loadFromURL(a,c,b)},a.loadIntensityDataFromFile=function(a,b){m.loadFromFile(a,c,b)},a.loadColorMapFromURL=function(a,b){m.loadColorMapFromURL(a,d,b)},a.loadColorMapFromFile=function(a,b){m.loadColorMapFromFile(a,d,b)},a.clearScreen=function(){for(var b=a.model.children;b.length>0;)a.model.remove(b[0]);k(),a.resetView(),BrainBrowser.events.triggerEvent("clearscreen")}},BrainBrowser.SurfaceViewer.modules.rendering=function(a){"use strict";function b(e){var h,j,k=a.model;window.requestAnimationFrame(b),d=c||e,c=e,h=c-d,j=15e-5*h,a.autorotate.x&&(k.rotation.x+=j),a.autorotate.y&&(k.rotation.y+=j),a.autorotate.z&&(k.rotation.z+=j),i.render(f,g)}var c,d,e=new THREE.WebGLRenderer({preserveDrawingBuffer:!0}),f=new THREE.Scene,g=new THREE.PerspectiveCamera(30,a.dom_element.offsetWidth/a.dom_element.offsetHeight,1,3e3),h=new THREE.PointLight(16777215),i=e,j={},k=e.domElement;a.model=new THREE.Object3D,f.add(a.model),a.render=function(){var c=a.dom_element;e.setClearColor(0),e.setSize(c.offsetWidth,c.offsetHeight),c.appendChild(e.domElement),g.position.z=500,h.position.set(0,0,500),f.add(h),a.autorotate={},window.onresize=function(){i.setSize(c.offsetWidth,c.offsetHeight),g.aspect=c.offsetWidth/c.offsetHeight,g.updateProjectionMatrix()},window.onresize(),b()},a.canvasDataURL=function(){return e.domElement.toDataURL()},a.addEffect=function(b){var c;BrainBrowser.utils.isFunction(THREE[b])&&(c=new THREE[b](e),c.setSize(a.dom_element.offsetWidth,a.dom_element.offsetHeight),j[b]=c)},a.setEffect=function(a){i=j[a]?j[a]:e},a.setCameraPosition=function(a,b,c){g.position.set(a,b,c),h.position.set(a,b,c)},a.resetView=function(){var b,c,d,e,f=a.model,i=new THREE.Matrix4;for(i.getInverse(f.matrix),f.applyMatrix(i),g.position.set(0,0,500),h.position.set(0,0,500),d=0,e=a.model.children.length;e>d;d++)b=f.children[d],b.centroid?b.position.set(b.centroid.x,b.centroid.y,b.centroid.z):b.position.set(0,0,0),b.rotation.set(0,0,0),c=b.getObjectByName("__WIREFRAME__")},a.zoom=function(a){var b=g.position,c=b.z/a;c>g.near&&c<.9*g.far&&(b.z=c,h.position.z=c)},a.setClearColor=function(a){e.setClearColor(a,1)},a.drawDot=function(b,c,d,e,g){e=e||2,e=e>=0?e:0,g=g>=0?g:16711680;var h=new THREE.SphereGeometry(e),i=new THREE.MeshBasicMaterial({color:g}),j=new THREE.Mesh(h,i);return j.position.set(b,c,d),a.model?a.model.add(j):f.add(j),j},a.pick=function(b,c){b=void 0===b?a.mouse.x:b,c=void 0===c?a.mouse.y:c,b=b/a.dom_element.offsetWidth*2-1,c=-c/a.dom_element.offsetHeight*2+1;var d,e,f,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x=a.model,y=new THREE.Projector,z=new THREE.Raycaster,A=new THREE.Vector3(b,c,g.near),B=null,C=new THREE.Matrix4;for(y.unprojectVector(A,g),z.set(g.position,A.sub(g.position).normalize()),d=z.intersectObject(x,!0),r=0;r<d.length;r++)if(!d[r].object.__PICK_IGNORE__){B=d[r];break}if(null!==B)if(f=B.object,i=B.indices,f.annotation_info)e={index:f.annotation_info.vertex,point:f.annotation_info.position,object:f};else{for(t=f.centroid,u=t.x,v=t.y,w=t.z,C.getInverse(f.matrixWorld),h=B.point.applyMatrix4(C),m=f.geometry.original_data.vertices,n=f.geometry.original_data.indices,j=o=n[i[0]],k=new THREE.Vector3(m[3*o],m[3*o+1],m[3*o+2]),l=h.distanceTo(new THREE.Vector3(k.x-u,k.y-v,k.z-w)),r=1,s=i.length;s>r;r++)o=n[i[r]],p=new THREE.Vector3(m[3*o],m[3*o+1],m[3*o+2]),q=h.distanceTo(new THREE.Vector3(p.x-u,p.y-v,p.z-w)),l>q&&(j=o,k=p,l=q);e={index:j,point:k,object:f}}else e=null;return e},function(){function b(a,b){var c,d,e=new THREE.Matrix4,f=a.x,i=a.y;if(null!==n)if(c=f-n,d=i-o,"rotate"===m){e.getInverse(l.matrix);var j=new THREE.Vector3(1,0,0).applyMatrix4(e).normalize();l.rotateOnAxis(j,d/150),e.getInverse(l.matrix),j=new THREE.Vector3(0,1,0).applyMatrix4(e).normalize(),l.rotateOnAxis(j,c/150)}else b=b||1,b*=g.position.z/500,g.position.x-=c*b*.25,h.position.x-=c*b*.25,g.position.y+=d*b*.25,h.position.y+=d*b*.25;n=f,o=i}function c(){var b,c=a.touches[0].x-a.touches[1].x,d=a.touches[0].y-a.touches[1].y,e=Math.sqrt(c*c+d*d);null!==p&&(b=e-p,a.zoom(1+.01*b)),p=e}function d(c){c.preventDefault(),c.stopPropagation(),b(a.mouse,1.1)}function e(d){d.preventDefault(),d.stopPropagation(),"zoom"===m?c():b(a.touches[0],2)}function f(){document.removeEventListener("mousemove",d,!1),document.removeEventListener("mouseup",f,!1),n=null,o=null}function i(){document.removeEventListener("touchmove",e,!1),document.removeEventListener("touchend",i,!1),n=null,o=null,p=null}function j(b){var c=Math.max(-1,Math.min(1,b.wheelDelta||-b.detail));b.preventDefault(),b.stopPropagation(),a.zoom(1+.05*c)}var l=a.model,m="rotate",n=null,o=null,p=null;k.addEventListener("mousedown",function(a){document.addEventListener("mousemove",d,!1),document.addEventListener("mouseup",f,!1),m=1===a.which?"rotate":"translate"},!1),k.addEventListener("touchstart",function(a){document.addEventListener("touchmove",e,!1),document.addEventListener("touchend",i,!1),m=1===a.touches.length?"rotate":2===a.touches.length?"zoom":"translate"},!1),k.addEventListener("mousewheel",j,!1),k.addEventListener("DOMMouseScroll",j,!1),k.addEventListener("contextmenu",function(a){a.preventDefault(),a.stopPropagation()},!1)}()},BrainBrowser.SurfaceViewer.modules.views=function(a){"use strict";function b(a){return a*Math.PI/180}var c={medialView:function(c){var d=a.model;c.split&&(d.getObjectByName("left").position.x-=100,d.getObjectByName("left").rotation.z-=b(90),d.getObjectByName("right").position.x+=100,d.getObjectByName("right").rotation.z+=b(90),d.rotation.x+=b(-90))},lateralView:function(c){var d,e,f=a.model;c.split&&(d=f.getObjectByName("left"),e=f.getObjectByName("right"),d.position.x-=100,d.rotation.z+=b(-90),e.position.x+=100,e.rotation.z+=b(90),f.rotation.x+=b(90),f.rotation.y+=b(180))},inferiorView:function(){a.model.rotation.y+=b(180)},anteriorView:function(){a.resetView(),a.model.rotation.x+=b(-90),a.model.rotation.z+=b(180)},posteriorView:function(){a.resetView(),a.model.rotation.x+=b(-90)}};a.setTransparency=function(b,c){c=c||{};var d,e,f,g=c.shape_name,h=a.model.getObjectByName(g);d=h?[h]:a.model.children||[],d.forEach(function(a){e=a.material,e.opacity=b,e.transparent=1===b?!1:!0,f=a.getObjectByName("__WIREFRAME__"),f&&(f.material.opacity=e.opacity,f.material.transparent=e.transparent)})},a.setWireframe=function(b,c){c=c||{};var d,e,f=c.shape_name,g=a.model.getObjectByName(f);d=g?[g]:a.model.children||[],d.forEach(function(a){e=a.getObjectByName("__WIREFRAME__"),e&&(a.visible=!b,e.visible=b,a.wireframe_active=b)})},a.setView=function(b,d){var e=b+"View",f=a.model_data.get(d);a.resetView(),f&&BrainBrowser.utils.isFunction(c[e])&&c[e](f)},a.separateHalves=function(b,c){b=b||1,c=c||{},a.model_data.get(c.model_name).split&&(a.model.children[0].position.x-=b,a.model.children[1].position.x+=b)}};