/*
* BrainBrowser: Web-based Neurological Visualization Tools
* (https://brainbrowser.cbrain.mcgill.ca)
*
* Copyright (C) 2011
* The Royal Institution for the Advancement of Learning
* McGill University
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
* BrainBrowser v2.0.1
*
* Author: Tarek Sherif  <tsherif@gmail.com> (http://tareksherif.ca/)
* Author: Nicolas Kassis
*/
!function(){"use strict";var a="2.0.1";a=a.indexOf("BRAINBROWSER_VERSION")>0?"D.E.V":a,window.BrainBrowser={version:a},window.requestAnimationFrame=window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(a){return window.setTimeout(a,1e3/60)},window.cancelAnimationFrame=window.cancelAnimationFrame||function(a){window.clearTimeout(a)}}(),function(){"use strict";function a(b,c,d,e){return c>d?e(b):void Object.keys(b).forEach(function(f){a(b[f],c+1,d,e)})}BrainBrowser.createTreeStore=function(){var b={};return{set:function(){var a,c,d,e,f=arguments[arguments.length-1],g=Array.prototype.slice.call(arguments,0,arguments.length-1),h=b;for(c=0,d=g.length-1;d>c;c++){if(a=g[c],h[a]&&"object"!=typeof h[a])throw e="Hash key '["+g.slice(0,c+1).join("][")+"]' has already been set to a non-object value.\nCannot set '["+g.join("][")+"]'",BrainBrowser.events.triggerEvent("error",e),new Error(e);h[a]||(h[a]={}),h=h[a]}a=g[c],h[a]=f},get:function(){var a,c,d,e=Array.prototype.slice.call(arguments),f=b;if(0===e.length)return b;for(c=0,d=e.length-1;d>c;c++){if(a=e[c],void 0===f[a])return null;f=f[a]}return a=e[c],void 0!==f[a]?f[a]:null},remove:function(){var a,c,d,e,f=Array.prototype.slice.call(arguments),g=b;for(c=0,d=f.length-1;d>c;c++){if(a=f[c],void 0===g[a])return null;g=g[a]}return a=f[c],e=g[a],g[a]=void 0,e},reset:function(a){a=a&&"object"==typeof a?a:{},b=a},forEach:function(c,d){c=c>0?c:1,a(b,1,c,d)}}}}(),function(){"use strict";BrainBrowser.createColorMap=function(a){function b(a,b,d,e){var f,g,h,i=document.createElement("canvas"),j=new Array(256);for(i.width=256,i.height=d,f=0;256>f;f++)e?j[255-f]=f:j[f]=f;for(a=c.mapColors(j,{scale255:!0}),h=i.getContext("2d"),g=0;256>g;g++)h.fillStyle="rgb("+Math.floor(a[4*g])+", "+Math.floor(a[4*g+1])+", "+Math.floor(a[4*g+2])+")",h.fillRect(g,0,1,b);return i}var c={createCanvasWithScale:function(a,d,e){e=e||{};var f,g,h=c.colors,i=e.flip,j=d-a;return f=b(h,20,40,i),g=f.getContext("2d"),g.fillStyle="#FFA000",g.fillRect(.5,20,1,10),g.fillText(a.toPrecision(3),.5,40),g.fillRect(f.width/4,20,1,10),g.fillText((a+.25*j).toPrecision(3),.25*f.width,40),g.fillRect(f.width/2,20,1,10),g.fillText((a+.5*j).toPrecision(3),.5*f.width,40),g.fillRect(3*f.width/4,20,1,10),g.fillText((a+.75*j).toPrecision(3),.75*f.width,40),g.fillRect(f.width-.5,20,1,10),g.fillText(d.toPrecision(3),f.width-20,40),f},mapColors:function(a,b){b=b||{};var d,e,f,g,h=void 0===b.min?0:b.min,i=void 0===b.max?255:b.max,j=void 0===b.scale255?!1:b.scale255,k=void 0===b.brightness?0:b.brightness,l=void 0===b.contrast?1:b.contrast,m=void 0===b.alpha?1:b.alpha,n=b.destination||[],o=c.colors,p=o.length,q=i-h,r=(q+q/p)/p,s=j?255:1,t=[];for(m*=s,d=0,e=a.length;e>d;d++)g=a[d],f=h>=g?0:a[d]>i?p-1:Math.floor((g-h)/r),t=o[f]||[0,0,0],n[4*d+0]=s*(t[0]*l+k),n[4*d+1]=s*(t[1]*l+k),n[4*d+2]=s*(t[2]*l+k),n[4*d+3]=m;return n}};return function(){if(a){a=a.replace(/^\s+/,"").replace(/\s+$/,"");var b,d,e,f,g,h=a.split(/\n/),i=[];for(b=0,e=h.length;e>b;b++)if(g=h[b].replace(/^\s+/,"").replace(/\s+$/,"").split(/\s+/).slice(0,4),f=g.length,!(3>f)){for(d=0;f>d;d++)g[d]=parseFloat(g[d]);4>f&&g.push(1),i.push(g)}c.colors=i}}(),c}}(),function(){"use strict";var a=BrainBrowser.createTreeStore();BrainBrowser.config={set:function(b,c){b=b||"";var d=b.split(".");d.push(c),a.set.apply(a,d)},get:function(b){b=b||"";var c=b.split(".");return a.get.apply(a,c)}}}(),function(){"use strict";var a=[];BrainBrowser.events={addEventListener:function(b,c){a[b]||(a[b]=[]),a[b].push(c)},triggerEvent:function(b){var c=Array.prototype.slice.call(arguments,1);a[b]&&a[b].forEach(function(a){setTimeout(function(){a.apply(null,c)},0)})}}}(),function(){"use strict";var a=BrainBrowser.loader={loadFromURL:function(b,c,d){d=d||{};var e,f=new XMLHttpRequest,g=d.result_type,h=b.split("/"),i=h[h.length-1];f.open("GET",b),"arraybuffer"===g&&(f.responseType="arraybuffer"),f.onreadystatechange=function(){if(4===f.readyState){if(e=f.status,!(e>=200&&300>e||304===e)){var g="error loading URL: "+b+"\nHTTP Response: "+f.status+"\nHTTP Status: "+f.statusText+"\nResponse was: \n"+f.response;throw BrainBrowser.events.triggerEvent("error",g),new Error(g)}a.checkCancel(d)||c(f.response,i,d)}},f.send()},loadFromFile:function(a,b,c){var d=a.files;if(0!==d.length){c=c||{};var e=c.result_type,f=new FileReader,g=a.value.split("\\"),h=g[g.length-1];f.file=d[0],f.onloadend=function(a){b(a.target.result,h,c)},f.onerror=function(){var a="error reading file: "+h;throw BrainBrowser.events.triggerEvent("error",a),new Error(a)},"arraybuffer"===e?f.readAsArrayBuffer(d[0]):f.readAsText(d[0])}},loadColorMapFromURL:function(a,b,c){BrainBrowser.loader.loadFromURL(a,function(a,c,d){b(BrainBrowser.createColorMap(a),c,d)},c)},loadColorMapFromFile:function(a,b,c){BrainBrowser.loader.loadFromFile(a,function(a,c,d){b(BrainBrowser.createColorMap(a),c,d)},c)},checkCancel:function(a){a=a||{},BrainBrowser.utils.isFunction(a)&&(a={test:a});var b=a.test,c=a.cleanup,d=!1;return b&&b()&&(d=!0,c&&c()),d}}}(),function(){"use strict";BrainBrowser.utils={canvasEnabled:function(){return!!document.createElement("canvas")},webglEnabled:function(){var a=document.createElement("canvas");try{return!(!a||!window.WebGLRenderingContext||!a.getContext("webgl")&&!a.getContext("experimental-webgl"))}catch(b){return!1}},webWorkersEnabled:function(){return!!window.Worker},webGLErrorMessage:function(){var a,b='BrainBrowser requires <a href="http://khronos.org/webgl/wiki/Getting_a_WebGL_Implementation">WebGL</a>.<br/>';return b+=window.WebGLRenderingContext?"Your browser seems to support it, but it is <br/> disabled or unavailable.<br/>":"Your browser does not seem to support it.<br/>",b+='Test your browser\'s WebGL support <a href="http://get.webgl.org/">here</a>.',a=document.createElement("div"),a.id="webgl-error",a.innerHTML=b,a},isFunction:function(a){return a instanceof Function||"function"==typeof a},isNumeric:function(a){return!isNaN(parseFloat(a))},min:function(){var a=Array.prototype.slice.call(arguments);a=1===a.length&&Array.isArray(a[0])?a[0]:a;var b,c,d=a[0];for(b=1,c=a.length;c>b;b++)a[b]<d&&(d=a[b]);return d},max:function(){var a=Array.prototype.slice.call(arguments);a=1===a.length&&Array.isArray(a[0])?a[0]:a;var b,c,d=a[0];for(b=1,c=a.length;c>b;b++)a[b]>d&&(d=a[b]);return d},getOffset:function(a){for(var b=0,c=0;a.offsetParent;)b+=a.offsetTop,c+=a.offsetLeft,a=a.offsetParent;return{top:b,left:c}},captureMouse:function(a){var b={x:0,y:0,left:!1,middle:!1,right:!1};return document.addEventListener("mousemove",function(c){var d,e,f=BrainBrowser.utils.getOffset(a);void 0!==c.pageX?(d=c.pageX,e=c.pageY):(d=c.clientX+window.pageXOffset,e=c.clientY+window.pageYOffset),b.x=d-f.left,b.y=e-f.top},!1),a.addEventListener("mousedown",function(a){a.preventDefault(),0===a.button&&(b.left=!0),1===a.button&&(b.middle=!0),2===a.button&&(b.right=!0)},!1),a.addEventListener("mouseup",function(a){a.preventDefault(),0===a.button&&(b.left=!1),1===a.button&&(b.middle=!1),2===a.button&&(b.right=!1)},!1),a.addEventListener("mouseleave",function(a){a.preventDefault(),b.left=b.middle=b.right=!1},!1),a.addEventListener("contextmenu",function(a){a.preventDefault()},!1),b},captureTouch:function(a){function b(b){var d,e,f,g,h,i=BrainBrowser.utils.getOffset(a);for(c.length=g=b.touches.length,f=0;g>f;f++)h=b.touches[f],void 0!==h.pageX?(d=h.pageX,e=h.pageY):(d=h.clientX+window.pageXOffset,e=h.clientY+window.pageYOffset),c[f]=c[f]||{},c[f].x=d-i.left,c[f].y=e-i.top}var c=[];return a.addEventListener("touchstart",b,!1),a.addEventListener("touchmove",b,!1),a.addEventListener("touchend",b,!1),c}}}(),function(){"use strict";var a=BrainBrowser.VolumeViewer={};a.modules={},a.volume_loaders={},a.start=function(b,c){function d(b,c,d){var e=a.utils.axis_to_number[c],g=f.volumes[b],h=g.display[e];h.setSlice(d),h.updateCursor()}function e(){document.addEventListener("keydown",function(b){if(f.active_canvas){var c,d,e=f.active_canvas,g=b.which,h=e.getAttribute("data-volume-id"),i=f.volumes[h],j=e.getAttribute("data-axis-name"),k=a.utils.axis_to_number[j],l=i.display[a.utils.axis_to_number[j]],m={16:function(){var a=l.mouse.x,b=l.mouse.y;(l.mouse.left||l.mouse.middle||l.mouse.right)&&(l.last_position.x=a,l.last_position.y=b,f.synced&&f.volumes.forEach(function(c,d){if(d!==h){var e=c.display[k];e.last_position.x=a,e.last_position.y=b}}))},17:function(){l.anchor||(l.mouse.left||l.mouse.middle||l.mouse.right)&&(l.anchor={x:l.mouse.x,y:l.mouse.y})},37:function(){c=l.slice.width_space.name,i.position[c]>0&&i.position[c]--},38:function(){c=l.slice.height_space.name,i.position[c]<l.slice.height_space.space_length&&i.position[c]++},39:function(){c=l.slice.width_space.name,i.position[c]<l.slice.width_space.space_length&&i.position[c]++},40:function(){c=l.slice.height_space.name,i.position[c]>0&&i.position[c]--}};return"function"==typeof m[g]?(b.preventDefault(),m[g](),l.updateCursor(),f.redrawVolume(h),f.synced&&f.volumes.forEach(function(a,b){b!==h&&f.setCursor(b,j,l.cursor)}),!1):32===g&&(b.preventDefault(),i.data.time)?(d=b.shiftKey?Math.max(0,i.current_time-1):Math.min(i.current_time+1,i.data.time.space_length-1),i.current_time=d,f.synced&&f.volumes.forEach(function(a,c){c!==h&&(a.current_time=b.shiftKey?Math.max(0,Math.min(d,a.data.time.space_length-1)):Math.max(0,Math.min(d,a.data.time.space_length-1)))}),f.redrawVolumes(),!1):void 0}},!1),document.addEventListener("keyup",function(a){var b=a.which,c={17:function(){f.volumes.forEach(function(a){a.display.forEach(function(a){a.anchor=null})})}};return"function"==typeof c[b]?(a.preventDefault(),c[b](),!1):void 0},!1)}var f={dom_element:document.getElementById(b),volumes:[],synced:!1,panel_width:256,panel_height:256};Object.keys(a.modules).forEach(function(b){a.modules[b](f)}),console.log("BrainBrowser Volume Viewer v"+BrainBrowser.version);var g={};return f.fetchSlice=function(b,c,e,h){g[b]=g[b]||{},clearTimeout(g[b][c]),g[b][c]=setTimeout(function(){var g,i=f.volumes[b],j=a.utils.axis_to_number[c];void 0!==e&&(i.position[c]=e),g=i.slice(c),g.vol_id=b,g.axis_number=j,g.min=i.min,g.max=i.max,d(b,c,g),BrainBrowser.events.triggerEvent("sliceupdate",b,c,g),BrainBrowser.utils.isFunction(h)&&h(g)},0)},f.setPanelSize=function(a,b,c){c=c||{};var d,e,g,h=c.scale_image;h&&(d=f.panel_width,e=f.panel_height,g=Math.min(a/d,b/e)),f.panel_width=a>0?a:f.panel_width,f.panel_height=b>0?b:f.panel_height,f.volumes.forEach(function(d,e){d.display.forEach(function(d,i){d.setSize(f.panel_width,f.panel_height,c),h&&(d.zoom=d.zoom*g,d.image_center.x=a/2,d.image_center.y=b/2,f.setCursor(e,["xspace","yspace","zspace"][i],{x:d.image_center.x,y:d.image_center.y}))})}),h&&f.redrawVolumes()},e(),c(f),f}}(),function(){"use strict";var a={setSize:function(a,b){this.canvas.width=a,this.canvas.height=b},setSlice:function(a){this.slice=a,this.slice_image=this.slice.getImage(this.zoom)},refreshSliceImage:function(){this.slice_image=this.slice.getImage(this.zoom)},updateCursor:function(){var a=this.volume,b=this.slice,c=this.getImageOrigin();this.cursor.x=a.position[b.width_space.name]*Math.abs(b.width_space.step)*this.zoom+c.x,this.cursor.y=(b.height_space.space_length-a.position[b.height_space.name])*Math.abs(b.height_space.step)*this.zoom+c.y},followPointer:function(a){var b=a.x-this.last_position.x,c=a.y-this.last_position.y;this.image_center.x+=b,this.image_center.y+=c,this.cursor.x+=b,this.cursor.y+=c,this.last_position.x=a.x,this.last_position.y=a.y},reset:function(){this.zoom=1,this.image_center.x=this.canvas.width/2,this.image_center.y=this.canvas.height/2},getImageOrigin:function(){return{x:this.image_center.x-this.slice_image.width/2,y:this.image_center.y-this.slice_image.height/2}},drawSlice:function(){var a,b=this.slice_image;b&&(a=this.getImageOrigin(),this.context.putImageData(b,a.x,a.y))},drawCursor:function(a){var b,c,d,e,f,g,h=this.context,i=this.zoom,j=8*i;a=a||"#FF0000",h.save(),h.strokeStyle=a,h.fillStyle=a,d=i,b=this.cursor.x-d,c=this.cursor.y-d,h.lineWidth=2*d,h.beginPath(),h.moveTo(b,c-j),h.lineTo(b,c-d),h.moveTo(b,c+d),h.lineTo(b,c+j),h.moveTo(b-j,c),h.lineTo(b-d,c),h.moveTo(b+d,c),h.lineTo(b+j,c),h.stroke(),this.anchor&&(f=(this.anchor.x-this.cursor.x)/this.zoom,g=(this.anchor.y-this.cursor.y)/this.zoom,e=Math.sqrt(f*f+g*g),h.font="bold 12px arial",this.canvas.width-this.cursor.x<50?(h.textAlign="right",b=this.cursor.x-j):(h.textAlign="left",b=this.cursor.x+j),this.cursor.y<30?(h.textBaseline="top",c=this.cursor.y+j):(h.textBaseline="bottom",c=this.cursor.y-j),h.fillText(e.toFixed(2),b,c),h.lineWidth=1,h.beginPath(),h.arc(this.anchor.x,this.anchor.y,2*d,0,2*Math.PI),h.fill(),h.moveTo(this.anchor.x,this.anchor.y),h.lineTo(this.cursor.x,this.cursor.y),h.stroke()),h.restore()}};BrainBrowser.VolumeViewer.createPanel=function(b){b=b||{};var c={cursor:{x:0,y:0},last_position:{x:0,y:0},image_center:{x:0,y:0},zoom:1},d=Object.create(a);return Object.keys(c).forEach(function(a){d[a]=c[a]}),Object.keys(b).forEach(function(a){d[a]=b[a]}),d.canvas&&BrainBrowser.utils.isFunction(d.canvas.getContext)&&(d.context=d.canvas.getContext("2d"),d.mouse=BrainBrowser.utils.captureMouse(d.canvas),d.touches=BrainBrowser.utils.captureTouch(d.canvas)),d}}(),function(){"use strict";function a(a,b,c,d,e,f){var g,h,i,j,k,l=[];for(f=f||1,g=0;b>g;g++)for(h=0;c>h;h++)for(j=d?b-g-1:g,k=e?c-h-1:h,i=0;f>i;i++)l[(h*b+g)*f+i]=a[(k*b+j)*f+i];return l}BrainBrowser.VolumeViewer.utils={axis_to_number:{xspace:0,yspace:1,zspace:2},nearestNeighbor:function(b,c,d){var e=b.data,f=b.width,g=b.height,h=document.createElement("canvas").getContext("2d"),i=4;if(f===c&&g===d)return b;0>c&&d>0&&(e=a(e,f,g,!0,!1,i)),c=Math.abs(c),d=Math.abs(d);for(var j=h.createImageData(c,d),k=j.data,l=f/c,m=g/d,n=0;d>n;n++)for(var o=0;c>o;o++)for(var p=Math.floor(o*l),q=Math.floor(n*m),r=0;i>r;r++)k[Math.floor(n*c+o)*i+r]=e[Math.floor(q*f+p)*i+r];return j},rotateUint16Array90Left:function(a,b,c){var d,e,f=new Uint16Array(b*c);for(d=0;b>d;d++)for(e=0;c>e;e++)f[d*c+e]=a[e*b+(b-d)];return f},rotateUint16Array90Right:function(a,b,c){var d,e,f=new Uint16Array(b*c);for(d=0;b>d;d++)for(e=0;c>e;e++)f[d*c+e]=a[(c-e)*b+d];return f}}}(),BrainBrowser.VolumeViewer.modules.loading=function(a){"use strict";function b(a,b){var c,d=h.volume_loaders[a.type];if(!d)throw c="Unsuported Volume Type",BrainBrowser.events.triggerEvent("error",c),new Error(c);d(a,b)}function c(c,d,e){b(d,function(b){var f=0;a.volumes[c]=b,b.display=g(a.dom_element,c,d),b.color_map=a.default_color_map,["xspace","yspace","zspace"].forEach(function(d){var g=b.position[d]=Math.floor(b.header[d].space_length/2);a.fetchSlice(c,d,g,function(){3===++f&&BrainBrowser.utils.isFunction(e)&&e(b)})})})}function d(b,c,d){b.cursor_color=c,a.default_color_map=b,BrainBrowser.utils.isFunction(d)&&d(b)}function e(b,c,d,e){c.cursor_color=d,a.setVolumeColorMap(b,c),BrainBrowser.utils.isFunction(e)&&e(a.volumes[b],c)}function f(a,b,c,d){var e=document.getElementById(c).innerHTML.replace(/\{\{VOLID\}\}/gm,b),f=document.createElement("div");f.innerHTML=e;var g,h,i,j=f.childNodes,k=f.getElementsByClassName(d)[0];for(g=0,h=a.childNodes.length;h>g;g++)i=a.childNodes[g],1===i.nodeType&&(k.appendChild(i),g--,h--);return j}function g(b,c,d){var e,g=document.createElement("div"),i=a.volumes[c],j=[],k=d.template||{};if(g.classList.add("volume-container"),["xspace","yspace","zspace"].forEach(function(b){var d=document.createElement("canvas");d.width=a.panel_width,d.height=a.panel_height,d.setAttribute("data-volume-id",c),d.setAttribute("data-axis-name",b),d.classList.add("slice-display"),d.style.backgroundColor="#000000",g.appendChild(d),j.push(h.createPanel({volume:i,axis:b,canvas:d,cursor:{x:d.width/2,y:d.height/2},image_center:{x:d.width/2,y:d.height/2}}))}),k.element_id&&k.viewer_insert_class&&(e=f(g,c,k.element_id,k.viewer_insert_class),"function"==typeof k.complete&&k.complete(i,e),Array.prototype.forEach.call(e,function(a){1===a.nodeType&&g.appendChild(a)})),a.volumeUIControls){var l=document.createElement("div");l.className="volume-viewer-controls volume-controls",a.volumeUIControls.defer_until_page_load?BrainBrowser.events.addEventListener("ready",function(){g.appendChild(l),a.volumeUIControls(l,i,c)}):(a.volumeUIControls(l,i,c),g.appendChild(l))}return function(){var b=null;["xspace","yspace","zspace"].forEach(function(d,e){function f(b,f,g){var h={x:b.x,y:b.y};g&&(a.volumes.forEach(function(a){a.display.forEach(function(a){a.anchor=null})}),q.anchor={x:b.x,y:b.y}),f?(q.last_position.x=h.x,q.last_position.y=h.y,a.synced&&a.volumes.forEach(function(a,b){if(b!==c){var d=a.display[e];d.last_position.x=h.x,d.last_position.y=h.y}})):(a.setCursor(c,d,h),a.synced&&a.volumes.forEach(function(b,e){e!==c&&a.setCursor(e,d,h)}))}function g(b,f){var g={x:b.x,y:b.y};f?(q.followPointer(g),a.synced&&a.volumes.forEach(function(a,b){b!==c&&a.display[e].followPointer(g)})):(a.setCursor(c,d,g),a.synced&&a.volumes.forEach(function(b,e){e!==c&&a.setCursor(e,d,g)}))}function h(a){a.target===b&&(a.preventDefault(),a.stopPropagation(),g(q.mouse,a.shiftKey))}function i(a){a.target===b&&(a.preventDefault(),a.stopPropagation(),g(q.touches[0],3===q.touches.length))}function k(){document.removeEventListener("mousemove",h,!1),document.removeEventListener("mouseup",k,!1),a.volumes.forEach(function(a){a.display.forEach(function(a){a.anchor=null})}),b=null}function l(){document.removeEventListener("touchmove",i,!1),document.removeEventListener("touchend",l,!1),a.volumes.forEach(function(a){a.display.forEach(function(a){a.anchor=null})}),b=null}function m(){var a,b=q.touches[0].x-q.touches[1].x,c=q.touches[0].y-q.touches[1].y,d=Math.sqrt(b*b+c*c);null!==s&&(a=d-s,p(.2*a)),s=d}function n(){document.removeEventListener("touchmove",m,!1),document.removeEventListener("touchend",n,!1),s=null}function o(a){p(Math.max(-1,Math.min(1,a.wheelDelta||-a.detail)))}function p(b){event.preventDefault(),event.stopPropagation(),q.zoom=Math.max(q.zoom+.05*b,.05),a.fetchSlice(c,["xspace","yspace","zspace"][e]),a.synced&&a.volumes.forEach(function(d,f){if(f!==c){var g=d.display[e];g.zoom=Math.max(g.zoom+.05*b,.05),a.fetchSlice(f,["xspace","yspace","zspace"][e])}})}var q=j[e],r=q.canvas,s=null;r.addEventListener("mousedown",function(c){c.preventDefault(),c.stopPropagation(),a.active_canvas=b=c.target,document.addEventListener("mousemove",h,!1),document.addEventListener("mouseup",k,!1),f(q.mouse,c.shiftKey,c.ctrlKey)},!1),r.addEventListener("touchstart",function(c){c.preventDefault(),c.stopPropagation(),a.active_canvas=b=c.target,2===q.touches.length?(document.removeEventListener("touchmove",i,!1),document.removeEventListener("touchend",l,!1),document.addEventListener("touchmove",m,!1),document.addEventListener("touchend",n,!1)):(document.removeEventListener("touchmove",m,!1),document.removeEventListener("touchend",n,!1),document.addEventListener("touchmove",i,!1),document.addEventListener("touchend",l,!1),f(q.touches[0],3===q.touches.length,!0))},!1),r.addEventListener("mousewheel",o,!1),r.addEventListener("DOMMouseScroll",o,!1)})}(),b.appendChild(g),BrainBrowser.events.triggerEvent("volumeuiloaded",g,c),j}var h=BrainBrowser.VolumeViewer;a.loadVolumes=function(b){function d(d){c(d,g[d],function(){++j<h||(b.overlay&&h>1?a.createOverlay(f,function(){BrainBrowser.utils.isFunction(i)&&i(),BrainBrowser.events.triggerEvent("volumesloaded")}):(BrainBrowser.utils.isFunction(i)&&i(),BrainBrowser.events.triggerEvent("volumesloaded")))})}b=b||{};var e,f=b.overlay&&"object"==typeof b.overlay?b.overlay:{},g=b.volumes,h=b.volumes.length,i=b.complete,j=0;for(e=0;h>e;e++)d(e)},a.loadVolumeColorMapFromURL=function(a,b,c,d){BrainBrowser.loader.loadColorMapFromURL(b,function(b){e(a,b,c,d)})},a.loadDefaultColorMapFromURL=function(a,b,c){BrainBrowser.loader.loadColorMapFromURL(a,function(a){d(a,b,c)})},a.loadVolumeColorMapFromFile=function(a,b,c,d){BrainBrowser.loader.loadColorMapFromFile(b,function(b){e(a,b,c,d)})},a.loadDefaultColorMapFromFile=function(a,b,c){BrainBrowser.loader.loadColorMapFromFile(a,function(a){d(a,b,c)})},a.setVolumeColorMap=function(b,c){a.volumes[b].color_map=c},a.loadVolume=function(b,d){c(a.volumes.length,b,d)},a.clearVolumes=function(){a.volumes=[],a.active_canvas=null,a.dom_element.innerHTML=""},a.createOverlay=function(b,c){b=b||{},a.loadVolume({volumes:a.volumes,type:"overlay",template:b.template},c)}},BrainBrowser.VolumeViewer.modules.rendering=function(a){"use strict";var b=BrainBrowser.VolumeViewer;a.draw=function(){var b,c,d,e=4,f=e/2;a.volumes.forEach(function(g){g.display.forEach(function(h){c=h.canvas,b=h.context,b.globalAlpha=255,b.clearRect(0,0,c.width,c.height),d=g.color_map||a.default_color_map,h.drawSlice(),h.drawCursor(d.cursor_color),c===a.active_canvas&&(b.save(),b.strokeStyle="#EC2121",b.lineWidth=e,b.strokeRect(f,f,c.width-e,c.height-e),b.restore())})})},a.render=function(){BrainBrowser.events.triggerEvent("rendering"),function b(){window.requestAnimationFrame(b),a.draw()}()},a.setCursor=function(c,d,e){var f,g,h=a.volumes[c],i=b.utils.axis_to_number[d],j=h.display[i],k=j.slice,l=j.getImageOrigin(),m=j.zoom;j.cursor.x=e.x,j.cursor.y=e.y,e?(f=Math.floor((e.x-l.x)/m/Math.abs(k.width_space.step)),g=Math.floor(k.height_space.space_length-(e.y-l.y)/m/Math.abs(k.height_space.step))):(f=null,g=null),a.fetchSlice(c,k.width_space.name,f),a.fetchSlice(c,k.height_space.name,g)},a.redrawVolume=function(b){var c=a.volumes[b];a.fetchSlice(b,"xspace",c.position.xspace),a.fetchSlice(b,"yspace",c.position.yspace),a.fetchSlice(b,"zspace",c.position.zspace)},a.redrawVolumes=function(){a.volumes.forEach(function(b,c){a.redrawVolume(c)})},a.resetDisplays=function(){a.volumes.forEach(function(a){a.display.forEach(function(a){a.reset()})})}},function(){"use strict";function a(a,b){var c,d;try{c=JSON.parse(a)}catch(e){throw d="server did not respond with valid JSON\nResponse was: \n"+a,BrainBrowser.events.triggerEvent("error",d),new Error(d)}BrainBrowser.utils.isFunction(b)&&b(c)}function b(a,b,d){var f=Object.create(e);f.position={},f.current_time=0,f.data=c(a,new Uint8Array(b)),f.header=f.data.header,f.min=0,f.max=255,BrainBrowser.utils.isFunction(d)&&d(f)}function c(a,b){var c,d,e,g,h,i,j=Object.create(f);j.header=a,j.order=a.order,4===j.order.length&&(j.order=j.order.slice(1),j.time=a.time),j.xspace=a.xspace,j.yspace=a.yspace,j.zspace=a.zspace,j.xspace.name="xspace",j.yspace.name="yspace",j.zspace.name="zspace",j.xspace.space_length=parseFloat(j.xspace.space_length),j.yspace.space_length=parseFloat(j.yspace.space_length),j.zspace.space_length=parseFloat(j.zspace.space_length),c=j.xspace.start=parseFloat(j.xspace.start),d=j.yspace.start=parseFloat(j.yspace.start),e=j.zspace.start=parseFloat(j.zspace.start),j.xspace.step=parseFloat(j.xspace.step),j.yspace.step=parseFloat(j.yspace.step),j.zspace.step=parseFloat(j.zspace.step),j.xspace.direction_cosines=j.xspace.direction_cosines||[1,0,0],j.yspace.direction_cosines=j.yspace.direction_cosines||[0,1,0],j.zspace.direction_cosines=j.zspace.direction_cosines||[0,0,1],g=j.xspace.direction_cosines=j.xspace.direction_cosines.map(parseFloat),h=j.yspace.direction_cosines=j.yspace.direction_cosines.map(parseFloat),i=j.zspace.direction_cosines=j.zspace.direction_cosines.map(parseFloat),j.voxel_origin={x:c*g[0]+d*h[0]+e*i[0],y:c*g[1]+d*h[1]+e*i[1],z:c*g[2]+d*h[2]+e*i[2]},4===j.order.length&&(j.time.space_length=parseFloat(j.time.space_length),j.time.start=parseFloat(j.time.start),j.time.step=parseFloat(j.time.step));var k=j[j.order[0]],l=j[j.order[1]],m=j[j.order[2]];return k.height=parseFloat(l.space_length),k.height_space=l,k.width=parseFloat(m.space_length),k.width_space=m,l.height=parseFloat(m.space_length),l.height_space=m,l.width=parseFloat(k.space_length),l.width_space=k,m.height=parseFloat(l.space_length),m.height_space=l,m.width=parseFloat(k.space_length),m.width_space=k,k.offset=parseFloat(l.space_length)*parseFloat(m.space_length),l.offset=parseFloat(k.space_length),m.offset=parseFloat(k.space_length),k.slice_length=k.height*k.width,j.cached_slices={},j.data=b,j}var d=BrainBrowser.VolumeViewer,e={slice:function(a,b,c){b=void 0===b?this.position[a]:b,c=void 0===c?this.current_time:c;var e=this.data.slice(a,b,c);return e.color_map=this.color_map,e.min=this.min,e.max=this.max,e.axis=a,e.getImage=function(a){a=a||1;var b=document.createElement("canvas").getContext("2d"),c=e.color_map,f=b.createImageData(e.width,e.height);c.mapColors(e.data,{min:e.min,max:e.max,scale255:!0,brightness:0,contrast:1,alpha:e.alpha,destination:f.data});var g=e.width_space.step,h=e.height_space.step;return d.utils.nearestNeighbor(f,Math.floor(e.width*g*a),Math.floor(e.height*h*a))},e},getVoxelCoords:function(){return{x:this.position.xspace,y:this.position.yspace,z:this.position.zspace}},setVoxelCoords:function(a,b,c){this.position.xspace=a,this.position.yspace=b,this.position.zspace=c},getWorldCoords:function(){return this.voxelToWorld(this.position.xspace,this.position.yspace,this.position.zspace)},setWorldCoords:function(a,b,c){var d=this.worldToVoxel(a,b,c);this.position.xspace=d.x,this.position.yspace=d.y,this.position.zspace=d.z},voxelToWorld:function(a,b,c){var d={};d[this.data.order[0]]=a,d[this.data.order[1]]=b,d[this.data.order[2]]=c,a=d.xspace,b=d.yspace,c=d.zspace;var e=this.data.xspace.direction_cosines,f=this.data.yspace.direction_cosines,g=this.data.zspace.direction_cosines,h=this.data.xspace.step,i=this.data.yspace.step,j=this.data.zspace.step,k=this.data.voxel_origin;return{x:a*e[0]*h+b*f[0]*i+c*g[0]*j+k.x,y:a*e[1]*h+b*f[1]*i+c*g[1]*j+k.y,z:a*e[2]*h+b*f[2]*i+c*g[2]*j+k.z}},worldToVoxel:function(a,b,c){var d=this.data.xspace.direction_cosines,e=this.data.yspace.direction_cosines,f=this.data.zspace.direction_cosines,g=this.data.xspace.step,h=this.data.yspace.step,i=this.data.zspace.step,j=this.data.voxel_origin,k=(-j.x*d[0]-j.y*d[1]-j.z*d[2])/g,l=(-j.x*e[0]-j.y*e[1]-j.z*e[2])/h,m=(-j.x*f[0]-j.y*f[1]-j.z*f[2])/i,n={x:Math.round(a*d[0]/g+b*d[1]/g+c*d[2]/g+k),y:Math.round(a*e[0]/h+b*e[1]/h+c*e[2]/h+l),z:Math.round(a*f[0]/i+b*f[1]/i+c*f[2]/i+m)},o={};return o[this.data.order[0]]=n.x,o[this.data.order[1]]=n.y,o[this.data.order[2]]=n.z,{x:o.xspace,y:o.yspace,z:o.zspace}}},f={slice:function(a,b,c){var e,f=this.cached_slices,g=this[this.order[0]];if(c=c||0,f[a]=f[a]||[],f[a][c]=f[a][c]||[],this[a].step<0&&(b=this[a].space_length-b),void 0!==f[a][c][b])return e=f[a][c][b],e.alpha=1,e.number=b,e;if(void 0===this.order)return!1;var h=0;this.time&&(h=c*g.height*g.width*parseFloat(g.space_length));var i=this[a].width_space.step,j=this[a].height_space.step;e={};var k,l,m,n,o,p,q,r,s,t;if(this.order[0]===a)if(l=this[a].height*this[a].width,m=this[a].height,n=this[a].width,o=1,p=n,q=l,k=new Uint16Array(l),i>0)if(j>0)for(r=0;l>r;r++)k[r]=this.data[h+q*b+r];else for(r=m;r>0;r--)for(s=0;n>s;s++)k[(m-r)*n+s]=this.data[h+q*b+r*n+s];else if(0>j)for(r=0;m>r;r++)for(s=0;n>s;s++)k[r*n+s]=this.data[h+q*b+r*n+n-s];else for(r=m;r>0;r--)for(s=0;n>s;s++)k[(m-r)*n+s]=this.data[h+q*b+r*n+n-s];else if(this.order[1]===a)if(m=this[a].height,l=this[a].height*this[a].width,n=this[a].width,o=1,p=g.slice_length,q=g.width,k=new Uint8Array(l),0>j)for(s=0;m>s;s++)for(t=0;n>t;t++)k[s*n+t]=this.data[h+b*q+p*t+s];else for(s=m;s>=0;s--)for(t=0;n>t;t++)k[(m-s)*n+t]=this.data[h+b*q+p*t+s];else for(m=this[a].height,l=this[a].height*this[a].width,n=this[a].width,o=g.slice_length,p=g.width,q=1,k=new Uint16Array(l),s=0;m>s;s++)for(t=0;n>t;t++)k[s*n+t]=this.data[h+b+g.width*s+t*g.slice_length];return e.width_space=this[a].width_space,e.height_space=this[a].height_space,e.width=n,e.height=m,"xspace"===a&&"yspace"===this.xspace.height_space.name&&(k=this.zspace.step<0?d.utils.rotateUint16Array90Right(k,e.width,e.height):d.utils.rotateUint16Array90Left(k,e.width,e.height),e.width_space=this[a].height_space,e.height_space=this[a].width_space,e.width=m,e.height=n),"yspace"===a&&"xspace"===this.yspace.height_space.name&&(k=this.zspace.step<0?d.utils.rotateUint16Array90Right(k,e.width,e.height):d.utils.rotateUint16Array90Left(k,e.width,e.height),e.width_space=this[a].height_space,e.height_space=this[a].width_space,e.width=m,e.height=n),"zspace"===a&&"xspace"===this.zspace.height_space.name&&(k=d.utils.rotateUint16Array90Left(k,e.width,e.height),e.width_space=this[a].width_space,e.height_space=this[a].height_space,e.width=m,e.height=n),e.data=k,e.width_space=e.width_space||this[a].width_space,e.height_space=e.height_space||this[a].height_space,e.width=e.width||n,e.height=e.height||m,f[a][c][b]=e,e}};d.volume_loaders.minc=function(c,d){var e;if(c.header_url&&c.raw_data_url)BrainBrowser.loader.loadFromURL(c.header_url,function(e){a(e,function(a){BrainBrowser.loader.loadFromURL(c.raw_data_url,function(c){b(a,c,d)},{result_type:"arraybuffer"})})});else{if(!c.header_file||!c.raw_data_file)throw e="invalid volume description.\nDescription must contain property pair 'header_url' and 'raw_data_url', or\n'header_file' and 'raw_data_file'.",BrainBrowser.events.triggerEvent("error",e),new Error(e);BrainBrowser.loader.loadFromFile(c.header_file,function(e){a(e,function(a){BrainBrowser.loader.loadFromFile(c.raw_data_file,function(c){b(a,c,d)},{result_type:"arraybuffer"})})})}}}(),function(){"use strict";function a(a,b){var c,d,e,f,g,h,i,j=a.length,k=b.data,l=b.width,m=b.height,n=[];if(j>1){for(c=0;m>c;c+=1)for(e=0;l>e;e+=1)for(d=0;j>d;d+=1)n[d]=n[d]||0,f=a[d],c<f.height&&e<f.width&&(g=4*(c*l+e),h=(k[g+3]||0)/255,i=n[d],k[g]=(k[g+0]||0)*h+f.data[i+0]*(f.data[i+3]/255),k[g+1]=(k[g+1]||0)*h+f.data[i+1]*(f.data[i+3]/255),k[g+2]=(k[g+2]||0)*h+f.data[i+2]*(f.data[i+3]/255),k[g+3]=(k[g+3]||0)+f.data[i+3],n[d]+=4);for(c=3;c<k.length;c+=4)k[c]=255;return b}return a[0]}var b=BrainBrowser.VolumeViewer,c={slice:function(c,d,e){d=void 0===d?this.position[c]:d,e=void 0===e?this.current_time:e;var f=this,g=[];return f.volumes.forEach(function(a,b){var h=a.slice(c,d,e);h.alpha=f.blend_ratios[b],g.push(h)}),{height_space:g[0].height_space,width_space:g[0].width_space,getImage:function(c){c=c||1;var d,e,f,h=document.createElement("canvas").getContext("2d"),i=[];return g.forEach(function(a){var d=a.color_map,e=h.createImageData(a.width,a.height),f=Math.floor(a.width*a.width_space.step*c),g=Math.floor(a.height*a.height_space.step*c);d.mapColors(a.data,{min:a.min,max:a.max,scale255:!0,brightness:0,contrast:1,alpha:a.alpha,destination:e.data}),e=b.utils.nearestNeighbor(e,f,g),i.push(e)}),d=i.reduce(function(a,b){return Math.max(a,b.width)},0),e=i.reduce(function(a,b){return Math.max(a,b.height)},0),f=h.createImageData(d,e),a(i,f)}}},getVoxelCoords:function(){return{x:this.position.xspace,y:this.position.yspace,z:this.position.zspace}},setVoxelCoords:function(a,b,c){this.position.xspace=a,this.position.yspace=b,this.position.zspace=c},getWorldCoords:function(){return this.volumes[0].voxelToWorld(this.position.xspace,this.position.yspace,this.position.zspace)},setWorldCoords:function(a,b,c){var d=this.volumes[0].worldToVoxel(a,b,c);this.position.xspace=d.x,this.position.yspace=d.y,this.position.zspace=d.z}};b.volume_loaders.overlay=function(a,b){a=a||{};var d=a.volumes||[],e=Object.create(c);e.type="overlay",e.position={},e.header=d[0]?d[0].header:{},e.min=0,e.max=255,e.volumes=[],e.blend_ratios=[],d.forEach(function(a){e.volumes.push(a),e.blend_ratios.push(1/d.length)}),BrainBrowser.utils.isFunction(b)&&b(e)}}();